library("stringr")
read_sdf_file <- function(filename = "") {
	to.read = file(filename,'rb')
	type_string = readChar(to.read,11)
	hdrpos = readBin(to.read,"integer",size = 8, n = 1, endian = "big")
	datapos = readBin(to.read,"integer",size = 8, n = 1, endian = "big")
	ndatasets = readBin(to.read,"integer",size = 4, n = 1, endian = "big")
	hdrsize = readBin(to.read,"integer",size = 8, n = 1, endian = "big")
	variablemetas = readLines(to.read,n=ndatasets)
	extracted_meta = strsplit(variablemetas,' ')
	id = c()
	name = c()
	type = c()
	nbytes = c()
	ndims = c()
	nelems = c()
	for (i in 1:ndatasets ) {
		id[i] = as.numeric(extracted_meta[[i]][1])
		name[i] = extracted_meta[[i]][2]
		type[i] = extracted_meta[[i]][3]
		nbytes[i] = as.numeric(extracted_meta[[i]][4])
		ndims[i] = as.numeric(extracted_meta[[i]][5])
		nelems[i] = prod(as.numeric(extracted_meta[[i]][6:(6+ndims[i]-1)]))
	}
	rvar = data.frame(id, name, type, nbytes, ndims, nelems)
	outvar = list()
	seek(to.read,where = (hdrsize+19))
	for (i in order(id)) {
		endianess = "big"
		tdims = as.numeric(extracted_meta[[i]][6:(6+ndims[i]-1)])
		if (type[i] == 'i') {
			text_type = "int"
		} else if (type[i] == 'f') {
			text_type = "double"
		} else if (type[i] == 'b') {
			text_type = "raw"
			endianess = "little"
		} else if (type[i] == 'c') {
			text_type == "complex"
			text_type == "double"		
			tdims = c(2,tdims)
#			nbytes[i] = 2*nbytes[i]
			nelems[i] = 2*nelems[i]
		} else {
			text_type = "raw"
		}
		tout = array(data = readBin(to.read,text_type, size = nbytes[i], n = nelems[i], endian = endianess), dim = tdims)
		if (type[i] == 'c'){
			if (length(tdims) == 2) {
				tout = tout[1,] + tout[2,]*1i
			} else if (length(tdims) == 3){
				tout = tout[1,,] + tout[2,,]*1i
			}
		}
		outvar[[name[i]]] = tout
	}
	close(to.read)
	return(outvar)
}
