#Forplay
reset()
set_random_seed(52836);

import os

import scipy
from scipy import optimize

import numpy
from numpy import linalg

from sage.misc.decorators import infix_operator
@infix_operator('multiply')
def dot(a,b) : return vector([a[i]*b[i] for i in range(0,min(len(a),len(b)))])

#Actual Stuff

p = 5

#This is a unique way of addressing E_ijk
def var_name(_k) : 
    k=_k
    k.sort()
    return ("e"+join(map(str,k),""))

#Make the list of possible E for this dimension
v_var = reduce(lambda u,v : u+" "+v,list(set([var_name([j,k,l]) for j in range(0,p) for k in range(0,p) for l in range(0,p)])))
var(v_var)
v_vlist = eval(v_var.replace(" ",","))

#These are the ways of simplifying the various e_vars with things that we know from the fact that the prototype is an element of O(n,C)
#e_00k=e_0k=e_k=0
simp_1 = {eval(var_name([0,0,k])):0 for k in range(1,p)}
#The e_0jk= e_jk = delta(j,k)
simp_2 = {eval(var_name([0,k,k])):1 for k in range(1,p)}
simp_3 = {eval(var_name([0,j,k])):0 for j in range(1,p) for k in range(1+j,p)}

#This is the matrix A_jk = e_jnk where n is fixed
def A(n) : return matrix( [[eval(var_name([n,j,k])) for j in range(0,p)] for k in range(0,p)]).subs(simp_1).subs(simp_2).subs(simp_3)

#In this example we care only about the first two coordinates of the sigma points
print("This is the A matrix about sigma point^t 1")
print(A(1))

print("The next question is how far can we push the accuracy of a single state with 4 sigma points")
what_we_want = {e111:0}
print("This is the base A1")
print(A(1).subs(what_we_want))
print("We want the [1,1] element of A11 to be 3 or that,")
eq1 = (A(1)*A(1)).subs(what_we_want)[1,1]-3
print(eq1+3)
print("This is easily solveable so we will move up one more level")
print("The [1,1] element of A111, E11111 should be zero")
eq2 = (A(1)*A(1)*A(1)).subs(what_we_want)[1,1]
print(eq2)
print("Its not hard to believe this is a consistent system of polynomials")
print("The [1,1] element of A1111, E111111 should be 15")
eq3 = (A(1)*A(1)*A(1)*A(1)).subs(what_we_want)[1,1]-15
print((eq3+15).expand().simplify())
print("And the [1,1] element of A11111, E1111111 should be 0")
eq4 = (A(1)*A(1)*A(1)*A(1)*A(1)).subs(what_we_want)[1,1]
print(eq4)
print("And the [1,1] element of A111111, E11111111 should be 105")
eq5 = (A(1)*A(1)*A(1)*A(1)*A(1)*A(1)).subs(what_we_want)[1,1]-105
print(eq5)
eq6 = (A(1)*A(1)*A(1)*A(1)*A(1)*A(1)*A(1)).subs(what_we_want)[1,1]
print(eq6)
var('v')
v=0
print("We can solve this with axiom, assuming e123="+str(v))
axiom.restart()
filename = tmp_filename(ext=".axiom.input")
f=open(filename,'w')
f.write(("tsol:=radicalSolve("+str([eq1,eq2,eq3,eq4,eq5,eq6,e123,e124,e134])+",[e112,e113,e114,e122,e133,e144,e123,e124,e134])"))
f.close()
print(axiom.read(filename))
print("broke too late")
os.unlink(filename)
axiom.eval(")set fortran ints2floats off")
axiom.eval(")set fortran fortlength 1024")
axiom.eval(")set fortran defaulttype INTEGER")
nsols = eval(axiom.eval("#tsol").partition("T")[0].strip())
for k in range(0,nsols) :
    a = axiom.eval("(outputAsFortran(0=0),map(outputAsFortran,tsol("+str(k+1)+")))").replace(".0D0","").replace("DSQRT","sqrt").replace("=","==").partition("L")[0]
    a = map(lambda u : u.strip(),a.split("\n"))
    a.remove("")
    a.remove("")
    print(a)
print(str(nsols) + " solutions found")
print("The resulting A1 Matrix would be")
a = map(eval,a)
sol_subs = {a[k].lhs():a[k].rhs() for k in range(0,len(a))}
#sol_subs = {e112:1,e113:1,e122:sqrt(3),e133:-sqrt(3),e123:0}
tA1 = A(1).subs(what_we_want).subs(sol_subs)
print(tA1)
teig = linalg.eig(tA1.n())
print("The sigma point prototype")
print(matrix(teig[1]))
print("And the actual sigma points")
w_root=matrix(teig[1])[0]
w_root_i=w_root.apply_map(lambda u : 1/u)
print("Weight Vector " + str(w_root *dot* w_root))
print("Y1 " + str(matrix(teig[1])[1] *dot* w_root_i))
tSP = matrix(teig[1])
