#Forplay
reset()
#set_random_seed(52836+2);

import os

import scipy
from scipy import optimize

import numpy
from numpy import linalg

from sage.misc.decorators import infix_operator
@infix_operator('multiply')
def dot(a,b) : return vector([a[i]*b[i] for i in range(0,min(len(a),len(b)))])

#Actual Stuff

p = 7  #Number of sigma points we are going to allow
pd = 3 #Dimension we want to expand to

num_neg = 0

possible_vals = [
    [3,1],     #2D
    [2,1.33],  #3D
    [1.5,1.5], #4D
    [1.2,1.6], #5D
    [1,1.66],  #6D
    [.9,1.67] #7D but this is a guess
]
vals = possible_vals[pd-2]
vals = [0.1,1]

def E(d,k,j) :
    ee = matrix(QQ,d)
    ee[k,j]=1
    return ee

def G(n,j,k,theta) : return (cos(theta)-1)*(E(n,j,j)+E(n,k,k))+sin(theta)*(-E(n,j,k)+E(n,k,j)) + matrix.identity(n)

def to_cmatrix(n,pp,th) : return prod([G(n,pp[k][0],pp[k][1],th[k]) for k in range(0,len(pp))])

base_vars = reduce(lambda u,v : u+" "+v,["theta"+str(k) for k in range(0,p-1)])
var(base_vars)
base_vlist = eval(base_vars.replace(' ',','))

temp_order1 = [ [0,k+1] for k in range(0,p-1) ]
temp_order1.reverse()
SP_proto_base = to_cmatrix(p,temp_order1,base_vlist)

r_proto = to_cmatrix(p,temp_order1,[I*(random()-0.5)] + [random()*2*pi.n() for _ in range(0,p-2)])

#print("Prototype Base Form, Dimension : " + str(p-1))
#print(SP_proto_base)

print("Base Sigma Points")
w_root = SP_proto_base[0]
w_root_i = w_root.apply_map(lambda u: 1/u)
SP_base = matrix(flatten([[w_root *dot* w_root], [SP_proto_base[k] *dot* w_root_i for k in range(1,p) ]]))

tf_vars = reduce(lambda u,v : u+" "+v,["phi"+str(k) for k in range(0,(p-1)*(p-2)/2)])
var(tf_vars)
tf_vlist = eval(tf_vars.replace(' ',','))

print("Sigma Point Transform Matrix, Dimension : "+str((p-1)*(p-2)/2))
templist2 = [[j,k] for j in range(1,p) for k in range(j+1,p)]
#templist2.reverse()
tf = to_cmatrix(p,templist2,tf_vlist)

#This is a unique way of addressing E_ijk
def var_name(_k) : 
    k=_k
    k.sort()
    return ("e"+join(map(str,k),""))

#Make the list of possible E for this dimension
v_var = reduce(lambda u,v : u+" "+v,list(set([var_name([j,k,l]) for j in range(0,p) for k in range(0,p) for l in range(0,p)])))
var(v_var)
v_vlist = eval(v_var.replace(" ",","))

#These are the ways of simplifying the various e_vars with things that we know from the fact that the prototype is an element of O(n,C)
#e_00k=e_0k=e_k=0
simp_1 = {eval(var_name([0,0,k])):0 for k in range(1,p)}
#The e_0jk= e_jk = delta(j,k)
simp_2 = {eval(var_name([0,k,k])):1 for k in range(1,p)}
simp_3 = {eval(var_name([0,j,k])):0 for j in range(1,p) for k in range(1+j,p)}

#This is the matrix A_jk = e_jnk where n is fixed
def A(n) : return matrix( [[eval(var_name([n,j,k])) for j in range(0,p)] for k in range(0,p)]).subs(simp_1).subs(simp_2).subs(simp_3)

def Jacobi_Method(M) : 
    tM = M.__copy__()
    R = identity_matrix(p).n()
    for iter in range(0,100) :
        M_abs = tM.apply_map(abs)
        for k in range(0,p) :
            M_abs[k,k] = 0
        mele = max(M_abs.list())
        if(max(M_abs.list())<0.00001) : return(R.transpose(),tM)
        pivot = M_abs.list().index(max(M_abs.list()))
        p_j = floor(pivot/p)
        p_k = pivot%p
        dev = tM[p_k,p_k] - tM[p_j,p_j]
        if abs(dev)<0.001 : dev = 0.001
        theta = (atan(2*tM[p_j,p_k]/dev)/2).n()
        tR = G(p,p_j,p_k,theta).n()
        tM = tR*tM*tR.transpose()
        R = tR*R
    return(R.transpose(),tM)

#What we want to be zero
what_we_have = {e111:0,e112:0,e122:0,e222:0}

n_unknowns = (p-3)+2*(p-3)+(p-2)*(p-3)

start_point = [2*random()-1 for k in range(0,n_unknowns)]

tA1 = matrix(p,p,0.n())
tA1[0,1] = 1
tA1[1,0] = 1
tA2 = matrix(p,p,0.n())
tA2[0,2] = 1
tA2[2,0] = 1

def update_As_from_p(ev) :
    sind = 0
    tA1 = matrix(CC,p,p)
    tA1[0,1] = 1
    tA1[1,0] = 1
    tA2 = matrix(CC,p,p)
    tA2[0,2] = 1
    tA2[2,0] = 1
    for k in range(3,p) : #This are the values e12k which appear in both
        tA1[2,k] = ev[sind]
        tA1[k,2] = ev[sind]
        tA2[1,k] = ev[sind]
        tA2[k,1] = ev[sind]
        sind = sind+1
    for k in range(3,p) :
        tA1[1,k] = ev[sind]
        tA1[k,1] = ev[sind]
        sind = sind+1
        tA2[2,k] = ev[sind]
        tA2[k,2] = ev[sind]
        sind = sind+1
    for j in range(3,p) :
        for k in range(j,p) :
            tA1[j,k] = ev[sind]
            tA1[k,j] = ev[sind]
            sind = sind+1
            tA2[j,k] = ev[sind]
            tA2[k,j] = ev[sind]
            sind = sind+1
    for j in range(1,p-num_neg) :
        for k in range(1,num_neg+1) :
            tA1[j,p-k] = tA1[j,p-k]*I
            tA1[p-k,j] = tA1[p-k,j]*I
            tA2[j,p-k] = tA2[j,p-k]*I
            tA2[p-k,j] = tA2[p-k,j]*I
    
    return(tA1,tA2)

bottom = 0.1

(tA1,tA2) = update_As_from_p(start_point) 
print("Start guess of A1")
print(tA1.n(digits=3))
print("Start guess of A2")
print(tA2.n(digits=3))

var('v1,v2')
A1 = A(1).subs(what_we_have)
A2 = A(2).subs(what_we_have)
A11 = A1*A1
A22 = A2*A2
A12 = A1*A2
eqlist = (A1*A2-A2*A1).submatrix(1,1,p-1,p-1).list() + [
        A11[1,1] - v1,A22[2,2] - v2,
        A11[1,2],A22[1,2],
        A11[2,2] - v2]

def error_v(ev) :
    (tA1,tA2) = update_As_from_p(ev)
    tA11 = tA1*tA1
    tA22 = tA2*tA2
    er = map(abs,(tA1*tA2 - tA2*tA1).submatrix(1,1,p-1,p-1).list()) + [
        tA11[1,1] - vals[0],tA22[2,2] -vals[0],
        tA11[1,2],tA22[1,2],
        tA11[2,2] - vals[1],
        0,
        0,
        0,
        0
    ] 
    if num_neg !=0 :
        (tSP,res) = Jacobi_Method(tA1)
        er[-4] = sum(map(abs,map(imag,(tSP[0] *dot* tSP[0]).list())))
        er[-3] = sum(map(abs,map(imag,(tSP[1] *dot* tSP[0].apply_map(lambda u:1/u)).list())))
        er[-2] = sum(map(abs,map(imag,(tSP[2] *dot* tSP[0].apply_map(lambda u:1/u)).list())))
    else : 
        tSP = matrix(linalg.eig(tA1)[1])
    mval = min(map(abs,tSP[0].list()))
    if mval<bottom :
        er[-1] = 1/(mval+bottom)
    return er

n_unknowns_2 = (p-3)+(p-3)+(p-2)*(p-3)/2

start_point_2 = [2*random()-1 for k in range(0,n_unknowns_2)]

def update_A1_from_p(ev) :
    sind = 0
    tA1 = matrix(p,p,0.n())
    tA1[0,1] = 1
    tA1[1,0] = 1
    for k in range(3,p) : #This are the values e12k which appear in both
        tA1[2,k] = ev[sind]
        tA1[k,2] = ev[sind]
        sind = sind+1
    for k in range(3,p) :
        tA1[1,k] = ev[sind]
        tA1[k,1] = ev[sind]
        sind = sind+1
    for j in range(3,p) :
        for k in range(j,p) :
            tA1[j,k] = ev[sind]
            tA1[k,j] = ev[sind]
            sind = sind+1
    return(tA1)

def error_v_2(ev) :
    tA1 = update_A1_from_p(ev)
    te = linalg.eig(tA1)
    tSP = matrix(te[1])
    w_root_i = tSP[0].apply_map(lambda u : 1/u)
    tA2 = tSP*diagonal_matrix(tSP[2] *dot* w_root_i)*tSP.transpose()
    tA11 = tA1*tA1
    tA22 = tA2*tA2
    er = [
        tA2[2,2],
        tA11[1,1] - vals[0],tA22[2,2] -vals[0],
        tA11[1,2],tA22[1,2],
        tA11[2,2] - vals[1]
    ] + [0 for k in range(0,n_unknowns_2-4)]
    mval = min(map(abs,tSP[0].list()))
    if mval<0.1 :
        er[-1] = 1/(mval+0.1)
    return er

#start_points = [ [10*random()-5 for k in range(0,n_unknowns_2)] for _ in range(0,10)]

#best_e = 1000
#best_v =  start_point
#for k in range(0,10) :
#    (sol,v) = optimize.leastsq(error_v_2,start_points[k],maxfev=1000)
#    er_v = vector(error_v_2(sol))
#    print("Solution")
#    tA1 = update_A1_from_p(sol)
#    tSP = matrix(linalg.eig(tA1.n())[1])
#    w_root_i = tSP[0].apply_map(lambda u : 1/u)
#    tSP[0] = tSP[0] *dot* tSP[0]
#    for k in range(1,p) : tSP[k] = tSP[k] *dot* w_root_i
#    print(tSP.n(digits=3))
#    print("Error")
 #   print(er_v.n(digits=3))
 #   if (er_v*er_v)<best_e :
 #       best_e = er_v*er_v
 #       best_v = sol

n_test = 20

start_points = [ [10*random()-5 for k in range(0,n_unknowns)] for _ in range(0,n_test)]

best_e = 1000
best_v =  start_point
for k in range(0,n_test) :
    (sol,v) = optimize.leastsq(error_v,start_points[k])
    er_v = vector(error_v(sol))
    print("Solution")
    (tA1,tA2) = update_As_from_p(sol)
    print("A1")
    print(tA1.n(digits=3))
    print("A2")
    print(tA2.n(digits=3))
#    tSP = matrix(linalg.eig(tA1.n())[1])
#    w_root_i = tSP[0].apply_map(lambda u : 1/u)
#    tSP[0] = tSP[0] *dot* tSP[0]
#    for k in range(1,p) : tSP[k] = tSP[k] *dot* w_root_i
#    print(tSP.n(digits=3))
    print("Error :"+str( sqrt(er_v*er_v).n(digits=3)) )
    print(er_v.n(digits=3))
    if (er_v*er_v)<best_e :
        best_e = er_v*er_v
        best_v = sol


print("")
print("Best Solution Error : " +str(sqrt(best_e)))
(tA1,tA2) = update_As_from_p(best_v)
print("tA1")
print(tA1.n(digits=3))
print("tA2")
print(tA2.n(digits=3))
print("tA11")
print( (tA1*tA1).n(digits=3) )
print("tA22")
print( (tA2*tA2).n(digits=3) )
print("Surplus")
print( (tA1*tA2-tA2*tA1).n(digits=3) )

(tSP,resid) = Jacobi_Method(tA1.n())
print("tSP")
print(tSP.n(digits=3))
print("Diag")
print(resid.n(digits=3))

w_root_i = tSP[0].apply_map(lambda u : 1/u)
print("tSP")
print(tSP.n(digits=3))

tA1 =tSP*diagonal_matrix(tSP[1] *dot* w_root_i)*tSP.transpose()
tA2 = tSP*diagonal_matrix(tSP[2] *dot* w_root_i)*tSP.transpose()

print("A1")
print(tA1.submatrix(0,0,3,3).n(digits=3))
print("A2")
print(tA2.submatrix(0,0,3,3).n(digits=3))
print("A11")
print( (tA1*tA1).submatrix(0,0,3,3).n(digits=3))
print("A22")
print( (tA2*tA2).submatrix(0,0,3,3).n(digits=3))

def patch(ws,jk) : return ([ws] + [zlist for m in range(1,jk[0]+1)] + [tSP[1].list()] + [zlist for m in range(jk[0]+2,jk[1]+1)] + [tSP[2].list()] + [zlist for m in range(jk[1]+2,pd+1)])

pair_list = [ [j,k] for j in range(0,pd) for k in range(j+1,pd) ]
w_root_s = (tSP[0]*(sqrt(1/len(pair_list)).n()*sqrt(pd-1).n())).list()
zlist = [0 for k in range(0,p)]
patchwork = (matrix(reduce(lambda u,v : [u[k]+v[k] for k in range(0,pd+1)],map(lambda u : patch(w_root_s,u),pair_list)))/sqrt(pd-1)).n()

w_root_i = patchwork[0].apply_map(lambda u : 1/u)
pA1 = patchwork*diagonal_matrix(patchwork[1] *dot* w_root_i)*patchwork.transpose()
pA2 = patchwork*diagonal_matrix(patchwork[2] *dot* w_root_i)*patchwork.transpose()
print("pA1")
print(pA1.n(digits=3))
print("pA2")
print(pA2.n(digits=3))

pA11 = patchwork*diagonal_matrix(patchwork[1] *dot* w_root_i *dot* patchwork[1] *dot* w_root_i)*patchwork.transpose()
pA22 = patchwork*diagonal_matrix(patchwork[2] *dot* w_root_i *dot* patchwork[2] *dot* w_root_i)*patchwork.transpose()
print("pA11")
print(pA11.n(digits=3))
print("pA22")
print(pA22.n(digits=3))
