load('../../SigmaPoint/Filters.sage')
load('../../SigmaPoint/Generate_Sigma_Points.sage')
load('TrikeFile.sage')
load('TrikeFunctions.sage')

import scipy
from scipy.stats.mstats import mquantiles

run_up = [ (0.0,0.0), (9.0e-2,0.0), (0.18,0.0), (0.27,0.0), (0.36,0.0), (0.45,0.0), (0.54,0.0), (0.63,0.0), (0.72,0.0), (0.81,0.0), (0.9,0.0), (0.99,0.0), (1.08,0.0), (1.17,0.0), (1.26,0.0), (1.35,0.0), (1.44,0.0), (1.53,0.0), (1.62,0.0), (1.71,0.0) ]

ahead = (1.8,0) #45

slow_down = [ (1.755,0.0), (1.665,0.0), (1.575,0.0), (1.485,0.0), (1.395,0.0), (1.305,0.0), (1.215,0.0), (1.125,0.0), (1.035,0.0), (0.945,0.0) ]

turn_right = (0.9,-0.21480045) #20

little_flick = [(-0.0,0.12951932), (-0.225,0.12951932)]

turn_reverse = (-0.45,0.12951932) # 66

speed_back_up = [(-0.225,0.12951932),(0.0,0.12951932),(0.0,0.0),(9.0e-2,0.0),(0.18,0.0),(0.27,0.0),(0.36,0.0),(0.45,0.0),(0.54,0.0),(0.63,0.0),(0.72,0.0),(0.81,0.0),(0.9,0.0),(0.99,0.0),(1.08,0.0),(1.17,0.0),(1.26,0.0),(1.35,0.0),(1.44,0.0),(1.53,0.0),(1.62,0.0),(1.71,0.0)]

#20 straight up
#slow down
#20 turn left

speed_up_again = [(0.945,0.0),(1.035,0.0),(1.125,0.0),(1.215,0.0),(1.305,0.0),(1.395,0.0),(1.485,0.0),(1.575,0.0),(1.665,0.0),(1.755,0.0)]

#17 straight up

slow_down_stop = [(1.71,0.0),(1.62,0.0),(1.53,0.0),(1.44,0.0),(1.35,0.0),(1.26,0.0),(1.17,0.0),(1.08,0.0),(0.99,0.0),(0.9,0.0),(0.81,0.0),(0.72,0.0),(0.63,0.0),(0.54,0.0),(0.45,0.0),(0.36,0.0),(0.27,0.0),(0.18,0.0),(9.0e-2,0.0),(2.220446e-16,0.0)]

original_run = map(vector,run_up + [ahead for _ in range(0,45)] + slow_down + [turn_right for _ in range(0,20)] + little_flick + [turn_reverse for _ in range(0,66)] + speed_back_up + [ahead for _ in range(0,20)] + slow_down + [turn_right for _ in range(0,20)] + speed_up_again + [ahead for _ in range(0,17)] + slow_down_stop)

original_s0 = vector([40.197,-30.097,1.5707963267948966,5.1191,5.6913,0.1257,-.0898])

def generate_truth(truth_s0,wvals,uvals) :
    state = [truth_s0 for _ in range(0,len(wvals)+1)]
    for k in range(0,len(wvals)) :
        state[k+1] = pedal_ahead(state[k],wvals[k],uvals[k]).n()
    return(state)

def run_EKF(scenario,obs_vals) :
    state_r = [scenario[2] for _ in range(0,scenario[0]+1)]
    for k in range(0,scenario[0]) :
        adv = ekfAdvance(pedal_ahead,Fee,Lee, (state_r[k],scenario[4],scenario[5][k]))
        tstate = performAdvancement(state_r[k],scenario[4],adv)
        if (scenario[8][k][0]==1) :
            meas = ekfMeasure(obs1f,H1ee,V1ee, (tstate,scenario[7],obs_vals[k]))
            state_r[k+1] = performMeasurement(tstate,scenario[7],meas)
        else :
            if(scenario[8][k][1]==1) :
                meas = ekfMeasure(obs2f,H2ee,V2ee, (tstate,scenario[7],obs_vals[k]))
                state_r[k+1] = performMeasurement(tstate,scenario[7],meas)
            else :
                state_r[k+1] = tstate
    return state_r

def run_spoint(scenario,obs_vals,spoint_gen1,alpha1,spoint_gen2,alpha2) :
    state_r = [scenario[2] for _ in range(0,scenario[0]+1)]
    spoint_prop = spoint_gen1(7+5).n()
    spoint_obs = spoint_gen2(7+2).n()
    
    for k in range(0,scenario[0]) :
        adv = sigmaAdvance(pedal_ahead,(state_r[k],scenario[4],scenario[5][k]),spoint_prop,alpha1)
        tstate = performAdvancement(state_r[k],scenario[4],adv)
        if (scenario[8][k][0]==1) :
            meas = sigmaMeasure(obs1f,(tstate,scenario[7],obs_vals[k]),spoint_obs,alpha2)
            state_r[k+1] = performMeasurement(tstate,scenario[7],meas)
        else :
            if(scenario[8][k][1]==1) :
                meas = sigmaMeasure(obs2f,(tstate,scenario[7],obs_vals[k]),spoint_obs,alpha2)
                state_r[k+1] = performMeasurement(tstate,scenario[7],meas)
            else :
                state_r[k+1] = tstate
    return state_r

def run_merge1(scenario,obs_vals,spoint_gen2,alpha2) :
    state_r = [scenario[2] for _ in range(0,scenario[0]+1)]
    spoint_obs = spoint_gen2(7+2).n()
    
    for k in range(0,scenario[0]) :
        adv = ekfAdvance(pedal_ahead,Fee,Lee, (state_r[k],scenario[4],scenario[5][k]))
        tstate = performAdvancement(state_r[k],scenario[4],adv)
        if (scenario[8][k][0]==1) :
            meas = sigmaMeasure(obs1f,(tstate,scenario[7],obs_vals[k]),spoint_obs,alpha2)
            state_r[k+1] = performMeasurement(tstate,scenario[7],meas)
        else :
            if(scenario[8][k][1]==1) :
                meas = sigmaMeasure(obs2f,(tstate,scenario[7],obs_vals[k]),spoint_obs,alpha2)
                state_r[k+1] = performMeasurement(tstate,scenario[7],meas)
            else :
                state_r[k+1] = tstate
    return state_r

Q_root = diagonal_matrix([ 0.238,(1.936E-3),(7.940E-2),(7.940E-2),1.701E-3 ])
P_root = diagonal_matrix([ 18.75,18.75,5*pi.n()/8,5*pi.n()/6,5*pi.n()/6,1.857E-2,1.857E-2 ])
R_root = diagonal_matrix([ 1*pi.n()/180, 2/3*pi.n()/180 ])

u_forward = [ vector([1.5,0]) for _ in range(0,10) ]
u_curve = [ vector([1,-.15]) for _ in range(0,10) ]

def generate_simple_run(wvals) :
    npoints = len(wvals)
    s0 = (original_s0+P_root*vector(numpy.random.normal(0,1,7)),P_root*P_root.transpose())
    w_var = (vector([0,0,0,0,0]),Q_root*Q_root.transpose())
    n_var = (vector([0,0]),R_root*R_root.transpose())
    nvals = [R_root*vector(numpy.random.normal(0,1,2)) for _ in range(0,npoints)]
    measures = [vector([0,0]) for _ in range(0,npoints)]
    uvals = original_run
    
    for k in range(0,npoints) :
        if ((k+5)%6==0) : measures[k] = vector([1,0])
        if ((k+2)%6==0) : measures[k] = vector([0,1])
    return (npoints,original_s0,s0,wvals,w_var,uvals,nvals,n_var,measures)

def generate_simple_scenarios() :
    npoints = len(original_run)
    numpy.random.seed(13603)
    wvals = [Q_root*vector(numpy.random.normal(0,1,5)) for _ in range(0,npoints)]
    truth = generate_truth(original_s0,wvals,original_run)

    show(line2d( map(lambda u : (u[0],u[1]),truth),rgbcolor=(.7,.2,.2)))

    folder = "Data/SimpleRuns/Run"
    for k in range(1,201) :
        scenario = generate_simple_run( wvals )
        if not os.path.exists(folder+('%05d'%k)) : 
            os.makedirs(folder+('%05d'%k))
        write_out_scenario(folder,scenario,k)

turn_left = (0.9,0.21480045)

alt_run = map(vector,run_up + [ahead for _ in range(0,30)] + slow_down + [turn_right for _ in range(0,30)] + speed_up_again + [ahead for _ in range(0,10)] + slow_down + [turn_left for _ in range(0,30)] + speed_up_again + [ahead for _ in range(0,10)] + slow_down + [turn_right for _ in range(0,25)] + speed_up_again + [ahead for _ in range(0,20)] + slow_down_stop)

alt_s0 = vector([10,45,-(pi/5).n(digits=4),5.1191,5.6913,0.1257,-.0898])

def generate_alt_run(wvals) :
    npoints = len(wvals)
    s0 = (alt_s0+P_root*vector(numpy.random.normal(0,1,7)),P_root*P_root.transpose())
    w_var = (vector([0,0,0,0,0]),Q_root*Q_root.transpose())
    n_var = (vector([0,0]),R_root*R_root.transpose())
    nvals = [R_root*vector(numpy.random.normal(0,1,2)) for _ in range(0,npoints)]
    measures = [vector([0,0]) for _ in range(0,npoints)]
    uvals = alt_run

    for k in range(0,npoints) :
        if ((k+5)%6==0) : measures[k] = vector([1,0])
        if ((k+2)%6==0) : measures[k] = vector([0,1])
    return (npoints,alt_s0,s0,wvals,w_var,uvals,nvals,n_var,measures)

def generate_alt_scenarios() :
    npoints = len(alt_run)
    numpy.random.seed(13603)
    wvals = [Q_root*vector(numpy.random.normal(0,1,5)) for _ in range(0,npoints)]
    truth = generate_truth(alt_s0,wvals,alt_run)

    show(line2d( map(lambda u : (u[0],u[1]),truth),rgbcolor=(.7,.2,.2)))

    folder = "Data/AltRuns/Run"
    for k in range(1,201) :
        scenario = generate_alt_run( wvals )
        if not os.path.exists(folder+('%05d'%k)) : 
            os.makedirs(folder+('%05d'%k))
        write_out_scenario(folder,scenario,k)


def generate_small_run(uvals,truth_s0,scale) : 
    npoints = 10
    s0 = (truth_s0+scale*P_root*vector(numpy.random.normal(0,1,7)),scale*scale*P_root*P_root.transpose())
    w_var = (vector([0,0,0,0,0]),Q_root*Q_root.transpose())
    wvals = [vector([0,0,0,0,0]) for _ in range(0,npoints)]
    n_var = (vector([0,0]),R_root*R_root.transpose())
    nvals = [vector([0,0]) for _ in range(0,npoints)]
    measures = [vector([0,0]) for _ in range(0,npoints)]

    for k in range(0,npoints) : 
        wvals[k] = Q_root*vector(numpy.random.normal(0,1,5))
        nvals[k] = R_root*vector(numpy.random.normal(0,1,2))
        if (k+3)%4 == 0 : measures[k] = vector([1,0])
        if (k+1)%4 == 0 : measures[k] = vector([0,1])
    
    return (npoints,truth_s0,s0,wvals,w_var,uvals,nvals,n_var,measures)
    
def generate_small_scenarios(inds) :
    start_points = map(vector,[
        [30,-10,  1*pi.n(),2*pi.n(),pi.n()/2, 0.2,-0.1],
        [50, 20,  pi.n()/2,1*pi.n(),2*pi.n(),-0.2,-0.1],
        [20,  0,4*pi.n()/3,0*pi.n(),pi.n()/3, 0.1, 0.2]
    ])
    usets = [u_forward,u_curve]
    scales = [1,0.5]
    return [generate_small_run(usets[inds[0]],start_points[inds[1]],scales[inds[2]]) for _ in range(0,300)]

rough_sets = [
    ('O3',Generate_Order3_nopair,1),
    ('O3 (0.75)',Generate_Order3_nopair,0.75),
    ('O3 (0.5)',Generate_Order3_nopair,0.5),
    ('O3 (0.25)',Generate_Order3_nopair,0.25),
    ('O5',Generate_Order5_nopair,1),
    ('O5 (0.75)',Generate_Order5_nopair,0.75),
    ('O5 (0.5)',Generate_Order5_nopair,0.5),
    ('O5 (0.25)',Generate_Order5_nopair,0.25),
    ('O7',Generate_Order7_nopair,1),
    ('O7 (0.75)',Generate_Order7_nopair,0.75),
    ('O7 (0.5)',Generate_Order7_nopair,0.5),
    ('O7 (0.25)',Generate_Order7_nopair,0.25),
    ('O9',Generate_Order9_nopair,1),
    ('O9 (0.75)',Generate_Order9_nopair,0.75),
    ('O9 (0.5)',Generate_Order9_nopair,0.5),
    ('O9 (0.25)',Generate_Order9_nopair,0.25)
]

def write_small_runs() :
    numpy.random.seed(97063)

    folder = "Data/ShortRuns/Run_000_"
    scenarios = generate_small_scenarios( (0,0,0) )
    for k in range(1,len(scenarios)+1) :
        if not os.path.exists(folder+('%05d'%k)) : 
            os.makedirs(folder+('%05d'%k))
        write_out_scenario(folder,scenarios[k-1],k)

    folder = "Data/ShortRuns/Run_100_"
    scenarios = generate_small_scenarios( (1,0,0) )
    for k in range(1,len(scenarios)+1) :
        if not os.path.exists(folder+('%05d'%k)) : 
            os.makedirs(folder+('%05d'%k))
        write_out_scenario(folder,scenarios[k-1],k)

    folder = "Data/ShortRuns/Run_010_"
    scenarios = generate_small_scenarios( (0,1,0) )
    for k in range(1,len(scenarios)+1) :
        if not os.path.exists(folder+('%05d'%k)) : 
            os.makedirs(folder+('%05d'%k))
        write_out_scenario(folder,scenarios[k-1],k)

    folder = "Data/ShortRuns/Run_110_"
    scenarios = generate_small_scenarios( (1,1,0) )
    for k in range(1,len(scenarios)+1) :
        if not os.path.exists(folder+('%05d'%k)) : 
            os.makedirs(folder+('%05d'%k))
        write_out_scenario(folder,scenarios[k-1],k)

    folder = "Data/ShortRuns/Run_020_"
    scenarios = generate_small_scenarios( (0,2,0) )
    for k in range(1,len(scenarios)+1) :
        if not os.path.exists(folder+('%05d'%k)) : 
            os.makedirs(folder+('%05d'%k))
        write_out_scenario(folder,scenarios[k-1],k)
        
    folder = "Data/ShortRuns/Run_120_"
    scenarios = generate_small_scenarios( (1,2,0) )
    for k in range(1,len(scenarios)+1) :
        if not os.path.exists(folder+('%05d'%k)) : 
            os.makedirs(folder+('%05d'%k))
        write_out_scenario(folder,scenarios[k-1],k)

def do_runs(scenarios,sets) :
    truths = map(lambda u : generate_truth(u[1],u[3],u[5]), scenarios)
    ekf_result = copy(truths)
    spoint_result = [copy(truths) for _ in range(0,len(sets))]
    obs_vals = [vector([0]) for _ in range(0,scenarios[0][0])]
    for j in range(0,len(scenarios)) :
        print("Run "+str(j))
        tscenario = scenarios[j]
        for k in range(0,tscenario[0]) :
            if (tscenario[8][k][0] == 1) :
                obs_vals[k] = obs1(truths[j][k+1],tscenario[6][k])
            else :
                if (tscenario[8][k][1] == 1) :
                    obs_vals[k] = obs2(truths[j][k+1],tscenario[6][k])
        tresult = run_EKF(tscenario,obs_vals)
        ekf_result[j] = map(lambda u : u[0],tresult)
        @parallel(3)
        def run_set(m) : return run_spoint(tscenario,obs_vals,sets[m][1],sets[m][2],sets[m][1],sets[m][2])
        tresults = sorted(run_set([0..(len(sets)-1])))
        for m in range(0,len(sets)) :
            spoint_result[m][j] = map(lambda u : u[0], tresults[m][1])
    return(truths,ekf_result,spoint_result)

def dump_data(f,data,lbl,lim,tick,k,pre) :
    ndata = len(lbl)
    npoints = 100
    f.write("summerydata"+str(k)+" = list(\n")
    f.write("\tstats = matrix(\n")
    f.write("\tc"+str(tuple(data))+"\n")
    f.write("\t,5,"+str(ndata)+"),\n")
    f.write("\tn = rep("+str(npoints)+","+str(ndata)+"),\n")
    f.write("\tnames = c"+str(tuple(lbl))+")\n")
    f.write("\n")
    f.write("svg(\'Plots/"+pre+str(k)+".svg',width=6,height="+str(0.2*ndata)+",pointsize=7)\n")
    f.write("par(mar=c(2,7,.1,.1))\n")
    f.write("bxp(summerydata"+str(k)+",show.names='True',horizontal=1,las=1,pars=list(boxcol='white',medlty='blank',medpch=16,medcex=1.0,whisklty=c(1,1),staplelty='blank',outcex=0.5,ylim=c"+str(lim)+",xaxt='n'),axes=F)\n")
    f.write("xtick = c"+str(tuple(tick))+"\n")
    f.write("abline(v=xtick,lty=1,lwd=0.5,col='lightgray')\n")
    f.write("axis(side=1,at=xtick)\n")
    f.write("axis(side=2,c(1:"+str(ndata)+"),summerydata"+str(k)+"$names,las=1)\n")
    f.write("dev.off()\n")
    f.write("\n\n")

def examine_small_runs() :
    fp = open("Small_Runs.R","w")

    print("Starting Scenario 0,0,0")
    scenarios = generate_small_scenarios( (0,0,0) )
    tresults = do_runs(scenarios,rough_sets)
    err_data = [ [] for _ in range(0,len(rough_sets)+1) ]
    err_labels = [ "A" for _ in range(0,len(rough_sets)+1) ]
    def find_err(v1,v2) : return sqrt( (v1[0]-v2[0])^2 + (v1[1]-v2[1])^2 )
    ekf_err = [ find_err(tresults[0][k][10],tresults[1][k][10]) for k in range(0,len(tresults[0])) ]
    err_data[len(rough_sets)] = map(n,mquantiles(ekf_err,prob=[.1,.25,.5,.75,.9]))
    err_labels[len(rough_sets)] = 'EKF'
    for j in range(0,len(rough_sets)) :
        err_t = [ find_err(tresults[0][k][10],tresults[2][j][k][10]) for k in range(0,len(tresults[0])) ]
        err_data[j] = map(n,mquantiles(err_t,prob=[.1,.25,.5,.75,.9]))
        err_labels[j] = rough_sets[j][0]
    dump_data(fp,flatten(err_data),err_labels,(0,40),[5,10,15,20,25,30,35,40],0,"Run_0_0_0")

    print("Starting Scenario 1,0,0")
    scenarios = generate_small_scenarios( (1,0,0) )
    tresults = do_runs(scenarios,rough_sets)
    err_data = [ [] for _ in range(0,len(rough_sets)+1) ]
    err_labels = [ "A" for _ in range(0,len(rough_sets)+1) ]
    def find_err(v1,v2) : return sqrt( (v1[0]-v2[0])^2 + (v1[1]-v2[1])^2 )
    ekf_err = [ find_err(tresults[0][k][10],tresults[1][k][10]) for k in range(0,len(tresults[0])) ]
    err_data[len(rough_sets)] = map(n,mquantiles(ekf_err,prob=[.1,.25,.5,.75,.9]))
    err_labels[len(rough_sets)] = 'EKF'
    for j in range(0,len(rough_sets)) :
        err_t = [ find_err(tresults[0][k][10],tresults[2][j][k][10]) for k in range(0,len(tresults[0])) ]
        err_data[j] = map(n,mquantiles(err_t,prob=[.1,.25,.5,.75,.9]))
        err_labels[j] = rough_sets[j][0]
    dump_data(fp,flatten(err_data),err_labels,(0,40),[5,10,15,20,25,30,35,40],0,"Run_1_0_0")

    print("Starting Scenario 0,1,0")
    scenarios = generate_small_scenarios( (0,1,0) )
    tresults = do_runs(scenarios,rough_sets)
    err_data = [ [] for _ in range(0,len(rough_sets)+1) ]
    err_labels = [ "A" for _ in range(0,len(rough_sets)+1) ]
    def find_err(v1,v2) : return sqrt( (v1[0]-v2[0])^2 + (v1[1]-v2[1])^2 )
    ekf_err = [ find_err(tresults[0][k][10],tresults[1][k][10]) for k in range(0,len(tresults[0])) ]
    err_data[len(rough_sets)] = map(n,mquantiles(ekf_err,prob=[.1,.25,.5,.75,.9]))
    err_labels[len(rough_sets)] = 'EKF'
    for j in range(0,len(rough_sets)) :
        err_t = [ find_err(tresults[0][k][10],tresults[2][j][k][10]) for k in range(0,len(tresults[0])) ]
        err_data[j] = map(n,mquantiles(err_t,prob=[.1,.25,.5,.75,.9]))
        err_labels[j] = rough_sets[j][0]
    dump_data(fp,flatten(err_data),err_labels,(0,40),[5,10,15,20,25,30,35,40],0,"Run_0_1_0")


    fp.close()

def do_run(ind) :
    scenario = read_in_scenario('Data/SimpleHigh',ind)
    truth = generate_truth(scenario[1],scenario[3],scenario[5])
    obs_vals = [vector([0]) for _ in range(scenario[0])]
    for k in range(0,scenario[0]) :
        if (scenario[8][k][0]==1) :
            obs_vals[k] = obs1(truth[k+1],scenario[6][k])
        else :
            if (scenario[8][k][1]==1) :
                obs_vals[k] = obs2(truth[k+1],scenario[6][k])
    ekf_result = run_EKF(scenario,obs_vals)
    spoint_result = run_spoint(scenario,obs_vals,Generate_Order4_pair,Generate_Order5_nopair)
    spoint_result2 = run_spoint(scenario,obs_vals,Generate_Order5_nopair,Generate_Order5_nopair)
    return(truth,ekf_result,spoint_result,spoint_result2)

#tst = do_run(4)
#l1 = line2d( map(lambda u : (u[0],u[1]),tst[0]),rgbcolor=(.7,.2,.2))
#l2 = line2d( map(lambda u : (u[0][0],u[0][1]),tst[1]),rgbcolor=(.2,.7,.2))
#l3 = line2d( map(lambda u : (u[0][0],u[0][1]),tst[2]),rgbcolor=(.2,.2,.7))
#l4 = line2d( map(lambda u : (u[0][0],u[0][1]),tst[3]),rgbcolor=(.2,.5,.5))

#l1+l2+l3+l4
