source('./blindtricycle_functions.R')

num_runs = 100

if(!exists('gotdata') || !gotdata) {
	run1 = list()
	run1$name = 'Perfects'
	run1$filter_names = c(
		'KF (S,W)',
		'KF (S)',
		'KF (W)' )
	run1$dataset = pull_in_datasets('SimpleRuns/RunRun',run1$name,1:num_runs)

	run2 = list()
	run2$name = 'BLSF'
	##Filters
	#BLSF (as KF)
	#BLSF 
	#BLSF relay 0.2
	run2$dataset = pull_in_datasets('SimpleRuns/RunRun',run2$name,1:num_runs)

	run3 = list()
	run3$name = 'BLSF_Long'
	## Filters
	#BLSF 1000 iterations 0.2 relax
	run3$dataset = pull_in_datasets('SimpleRuns/RunRun',run3$name,1:10)

	run4 = list()
	run4$name = 'EKF'
	run4$dataset = pull_in_datasets('SimpleRuns/RunRun',run4$name,1:num_runs)

	run5 = list()
	run5$name = 'Sigma'
	run5$filter_names = c(
		'UKF (O5)',
		'UKF (O7 0.4)',
		'FP UKF (O7 0.4)')
	run5$dataset = pull_in_datasets('SimpleRuns/RunRun',run5$name,1:num_runs)

	gotdata = TRUE
}

### Going to plot just run 4 as a demo
num = 1

ttick = c(0,76,96,166,216,236,282)/2
xtick = c(-20,0,40,80)
ytick = c(-40,0,40,60)


## BLSF plot 1 (Large Iterates)
things_to_plot = add_to_things_to_plot(run2$dataset[[1]],'truth_state','Truth','black',1)
things_to_plot = add_to_things_to_plot(run2$dataset[[1]],'filter01_back_0','BLSF (Iter 0)',clist$crimson,1,things_to_plot)
things_to_plot = add_to_things_to_plot(run2$dataset[[1]],'filter01_back_1','BLSF (Iter 1)',clist$lblue,1,things_to_plot)
things_to_plot = add_to_things_to_plot(run2$dataset[[1]],'filter01_back_2','BLSF (Iter 2)',clist$lgreen,1,things_to_plot)

generate_xy(things_to_plot,'BLSF_xy_norelax',xtick,ytick,ttick)

add_legend(things_to_plot$display_name,things_to_plot$colors,things_to_plot$linetypes)

dev.off()

##BLSF plot 2 (example small iterates)
things_to_plot = add_to_things_to_plot(run3$dataset[[num]],'truth_state','Truth','black',1)
things_to_plot = add_to_things_to_plot(run3$dataset[[num]],'filter00_back_0','BLSF (Iter 0)',clist$crimson,1,things_to_plot)
things_to_plot = add_to_things_to_plot(run3$dataset[[num]],'filter00_back_1','BLSF (Iter 1)',clist$curry,1,things_to_plot)
things_to_plot = add_to_things_to_plot(run3$dataset[[num]],'filter00_back_999','BLSF (Iter 999)',clist$lblue,1,things_to_plot)
things_to_plot = add_to_things_to_plot(run3$dataset[[num]],'filter00_back_1000','BLSF (Iter 1000)',clist$lgreen,1,things_to_plot)

generate_xy(things_to_plot,'BLSF_xy_relax',xtick,ytick,ttick)

add_legend(things_to_plot$display_name,things_to_plot$colors,things_to_plot$linetypes)

dev.off()


##BLSF plot 3
xy_small_mult(run3$dataset,'BLSF',things_to_plot,xtick,ytick)
dev.off()


##BLSF plot 3 ()
things_to_plot = add_to_things_to_plot(run2$dataset[[num]],'truth_state','Truth','black',1)
things_to_plot = add_to_things_to_plot(run2$dataset[[num]],'filter02_back_0','BLSF (Iter 0)',clist$crimson,1,things_to_plot)
things_to_plot = add_to_things_to_plot(run2$dataset[[num]],'filter02_back_1','BLSF (Iter 1)',clist$curry,1,things_to_plot)
things_to_plot = add_to_things_to_plot(run2$dataset[[num]],'filter02_back_49','BLSF (Iter 49)',clist$lblue,1,things_to_plot)
things_to_plot = add_to_things_to_plot(run2$dataset[[num]],'filter02_back_50','BLSF (Iter 50)',clist$lgreen,1,things_to_plot)

generate_xy(things_to_plot,'TBLSF_xy_relax',xtick,ytick,ttick)

add_legend(things_to_plot$display_name,things_to_plot$colors,things_to_plot$linetypes)

dev.off()


##BLSF plot 3
xy_small_mult(run2$dataset,'TBLSF',things_to_plot,xtick,ytick)
dev.off()

## Perfect Plots
things_to_plot = add_to_things_to_plot(run1$dataset[[num]],'truth_state','Truth','black',1)
things_to_plot = add_to_things_to_plot(run1$dataset[[num]],'filter00_forward_1','Perfect KF',clist$crimson,1,things_to_plot)
things_to_plot = add_to_things_to_plot(run1$dataset[[num]],'filter00_back_1','Perfect KF (Smoothed)',clist$purple,2,things_to_plot)

generate_xy(things_to_plot,'PEKF',xtick,ytick,ttick)
add_legend(things_to_plot$display_name,things_to_plot$colors,things_to_plot$linetypes)
dev.off()

xy_small_mult(run1$dataset,'PEKF',things_to_plot,xtick,ytick)
dev.off()

sigmas = sqrt(run1$dataset[[1]]$filter00_pval[1,]+run1$dataset[[1]]$filter00_pval[2,])
things_to_error = add_to_things_to_error(run1$dataset,'filter00_forward_1','Perfect KF',clist$crimson,1)
plot_errors(things_to_error,'PEKF',c(.1,1000),sort(c(1,10,100,things_to_error$q50_xy[[1]][283])),ttick,'y')
lines(run1$dataset[[1]]$time,sigmas,type='l',col='black')
legend("bottomleft","(x,y)",
	pch=c(-1,-1,21,23,25),
	lwd=c(1,1,1,1,1),
	legend=c("RMSE bound","RMSE","50%","75%","90%"),
	col=c('black',clist$crimson,makeTransparent(clist$crimson,50),clist$crimson,clist$crimson),
	pt.bg=rep(clist$crimson,5),
	lty=c(1,1,1,0,0))
dev.off()
things_to_error$things=0
plot_errors(things_to_error,'PEKF_justsig',c(.1,1000),sort(c(1,sigmas[283],10,100)),ttick,'y')
lines(run1$dataset[[1]]$time,sigmas,type='l',col='black')
dev.off()

things_to_error = add_to_things_to_error(run1$dataset,'filter00_forward_1','Perfect KF',clist$crimson,1)
things_to_error = add_to_things_to_error(run1$dataset,'filter00_back_1','Perfect KF (Smoothed)',clist$purple,1,things_to_error)
plot_errors(things_to_error,'PEKF_Smooth',c(.1,1000),sort(c(1,10,100,things_to_error$q50_xy[[1]][283])),ttick,'y')
legend("topleft","(x,y)",
	pch=c(-1,21,23,25),
	lwd=c(1,1,1,1),
	legend=c("RMSE","50%","75%","90%"),
	col=rep('grey50',4),
	pt.bg=rep('black',4),
	lty=c(1,1,0,0))
add_legend(things_to_error$display_name,things_to_error$colors,things_to_error$linetypes,1,'topright')
dev.off()

##EKF plot 1
things_to_plot = add_to_things_to_plot(run4$dataset[[num]],'truth_state','Truth','black',1)
things_to_plot = add_to_things_to_plot(run4$dataset[[num]],'filter00_forward_1','EKF',clist$curry,1,things_to_plot)
things_to_plot = add_to_things_to_plot(run4$dataset[[num]],'filter00_back_1','EKF (Smoothed)',clist$khaki,2,things_to_plot)

generate_xy(things_to_plot,'EKF',xtick,ytick,ttick)
add_legend(things_to_plot$display_name,things_to_plot$colors,things_to_plot$linetypes)
dev.off()

xy_small_mult(run4$dataset,'EKF',things_to_plot,xtick,ytick)
dev.off()

things_to_error = add_to_things_to_error(run4$dataset,'filter00_forward_1','EKF',clist$curry,1)
plot_errors(things_to_error,'EKF',c(.1,1000),sort(c(.1,100,things_to_error$q50_xy[[1]][283])),ttick,'y')
legend("bottomleft","(x,y)",
	pch=c(-1,21,23,25),
	lwd=c(1,1,1,1),
	legend=c("RMSE","50%","75%","90%"),
	col=c(clist$curry,makeTransparent(clist$curry,50),clist$curry,clist$curry),
	pt.bg=rep(clist$curry,4),
	lty=c(1,1,0,0))
dev.off()

things_to_error = add_to_things_to_error(run4$dataset,'filter00_back_1','EKF (Smoothed)',clist$khaki,1)
plot_errors(things_to_error,'EKF_Smooth',c(0.1,1000),sort(c(.1,100,things_to_error$q50_xy[[1]][283])),ttick,'y')
dev.off()

things_to_error = add_to_things_to_error(run1$dataset,'filter00_forward_1','Perfect KF',clist$crimson,1)
things_to_error = add_to_things_to_error(run4$dataset,'filter00_forward_1','EKF',clist$curry,1,things_to_error)
plot_errors(things_to_error,'EKF_Compare',c(0.1,1000),sort(c(1,100,things_to_error$q50_xy[[1]][283],things_to_error$q50_xy[[2]][283])),ttick,'y')
add_legend(things_to_error$display_name,things_to_error$colors,things_to_error$linetypes,1,'bottomleft')
dev.off()

things_to_error = add_to_things_to_error(run1$dataset,'filter00_forward_1','Perfect KF',clist$crimson,1)
things_to_error = add_to_things_to_error(run1$dataset,'filter00_back_1','Perfect KF (Smoothed)',clist$purple,1,things_to_error)
things_to_error = add_to_things_to_error(run4$dataset,'filter00_forward_1','EKF',clist$curry,1,things_to_error)
things_to_error = add_to_things_to_error(run4$dataset,'filter00_back_1','EKF (Smoothed)',clist$khaki,1,things_to_error)
plot_errors(things_to_error,'EKF_Compare_Smoothed',c(0.1,1000),sort(c(1,10,100,things_to_error$q50_xy[[1]][283],things_to_error$q50_xy[[3]][283])),ttick,'y')
legend('topleft',"(x,y)",
	pch=c(-1,21,23,25),
	lwd=c(1,1,1,1),
	legend=c("RMSE","50%","75%","90%"),
	col=rep('black',4),
#	col=c(clist$khaki,makeTransparent(clist$khaki,50),clist$khaki,clist$khaki),
	pt.bg=rep('gray50',4),
	lty=c(1,1,0,0))
add_legend(things_to_error$display_name,things_to_error$colors,things_to_error$linetypes,1,'topright')
dev.off()

## Iterative Smoother
things_to_plot = add_to_things_to_plot(run4$dataset[[num]],'truth_state','Truth','black',1)
things_to_plot = add_to_things_to_plot(run4$dataset[[num]],'filter00_forward_1','EKF',clist$curry,1,things_to_plot)
things_to_plot = add_to_things_to_plot(run4$dataset[[num]],'filter00_back_1','EKF (Smoothed)',clist$curry,2,things_to_plot)
things_to_plot = add_to_things_to_plot(run4$dataset[[num]],'filter00_forward_2','IS (Iter 1)',clist$khaki,1,things_to_plot)
things_to_plot = add_to_things_to_plot(run4$dataset[[num]],'filter00_back_2','IS (Smoothed 1)',clist$crimson,2,things_to_plot)

generate_xy(things_to_plot,'IS_2',xtick,ytick,ttick)
add_legend(things_to_plot$display_name,things_to_plot$colors,things_to_plot$linetypes)
dev.off()

xy_small_mult(run4$dataset,'IS_2',things_to_plot,xtick,ytick)
dev.off()

things_to_error = add_to_things_to_error(run4$dataset,'filter00_back_1','EKF (Smoothed)',clist$curry,1)
things_to_error = add_to_things_to_error(run4$dataset,'filter00_back_2','IS (Smoothed 1)',clist$khaki,1,things_to_error)
plot_errors(things_to_error,'IS_2_Smooth',c(0.1,1000),sort(c(1,10,100,things_to_error$q50_xy[[2]][283])),ttick,'y')
legend("bottomright","(x,y)",
	pch=c(-1,21,23,25),
	lwd=c(1,1,1,1),
	legend=c("RMSE","50%","75%","90%"),
	col=rep('black',4),
	pt.bg=rep('gray50',4),
	lty=c(1,1,0,0))
add_legend(things_to_error$display_name,things_to_error$colors,things_to_error$linetypes,1,'bottomleft')
dev.off()

things_to_error = add_to_things_to_error(run1$dataset,'filter00_back_1','Perfect KF',clist$purple,1)
things_to_error = add_to_things_to_error(run1$dataset,'filter00_back_20','IS (Smoothed 19, Perfect Init)',clist$lgreen,2,things_to_error)
plot_errors(things_to_error,'PIS_20_Smooth',c(0.1,1000),sort(c(1,10,100,things_to_error$q50_xy[[1]][283],things_to_error$q50_xy[[2]][283])),ttick,'y')
legend("topright","(x,y)",
	pch=c(-1,21,23,25),
	lwd=c(1,1,1,1),
	legend=c("RMSE","50%","75%","90%"),
	col=rep('black',4),
	pt.bg=rep('gray50',4),
	lty=c(1,1,0,0))
add_legend(things_to_error$display_name,things_to_error$colors,things_to_error$linetypes,1,'topleft')
dev.off()

things_to_plot = add_to_things_to_plot(run4$dataset[[num]],'truth_state','Truth','black',1)
things_to_plot = add_to_things_to_plot(run4$dataset[[num]],'filter00_back_19','IS (Smoothed 18)',clist$lblue,1,things_to_plot)
things_to_plot = add_to_things_to_plot(run4$dataset[[num]],'filter00_back_20','IS (Smoothed 19)',clist$lgreen,2,things_to_plot)

generate_xy(things_to_plot,'IS_20',xtick,ytick,ttick)
add_legend(things_to_plot$display_name,things_to_plot$colors,things_to_plot$linetypes)
dev.off()

xy_small_mult(run4$dataset,'IS_20',things_to_plot,xtick,ytick)
dev.off()

things_to_error = add_to_things_to_error(run4$dataset,'filter00_back_1','EKF (Smoothed)',clist$curry,1)
things_to_error = add_to_things_to_error(run4$dataset,'filter00_back_20','IS (Smoothed 19)',clist$lgreen,1,things_to_error)
things_to_error = add_to_things_to_error(run1$dataset,'filter00_back_1','Perfect KF (Smoothed)',clist$crimson,1,things_to_error)
plot_errors(things_to_error,'IS_20_Smooth',c(0.1,1000),sort(c(100,10,1,things_to_error$q50_xy[[2]][283],things_to_error$q50_xy[[3]][283])),ttick,'y')
legend("topright","(x,y)",
	pch=c(-1,21,23,25),
	lwd=c(1,1,1,1),
	legend=c("RMSE","50%","75%","90%"),
	col=rep('black',4),
	pt.bg=rep('gray50',4),
	lty=c(1,1,0,0))
add_legend(things_to_error$display_name,things_to_error$colors,things_to_error$linetypes,1,'topleft')
dev.off()

# BSEKF

things_to_error = add_to_things_to_error(run4$dataset,'filter00_back_20','IS (Smoothed 19)',clist$lgreen,1)
things_to_error = add_to_things_to_error(run4$dataset,'filter01_back_20','BSEKF (Smoothed 19)',clist$dblue,2,things_to_error)
plot_errors(things_to_error,'BSEKF_20_Smooth',c(0.1,1000),sort(c(100,10,1,things_to_error$q50_xy[[1]][283])),ttick,'y')
legend("topright","(x,y)",
	pch=c(-1,21,23,25),
	lwd=c(1,1,1,1),
	legend=c("RMSE","50%","75%","90%"),
	col=rep('black',4),
	pt.bg=rep('gray50',4),
	lty=c(1,1,0,0))
add_legend(things_to_error$display_name,things_to_error$colors,things_to_error$linetypes,1,'topleft')
dev.off()

things_to_error = add_to_things_to_error(run1$dataset,'filter00_back_1','Perfect KF (Smoothed)',clist$purple,1)
things_to_error = add_to_things_to_error(run1$dataset,'filter01_back_1','Just X PKF (Smoothed)',clist$dgreen,2,things_to_error)
plot_errors(things_to_error,'Perfect_noW_20_Smooth',c(0.1,1000),sort(c(10,100,1,things_to_error$q50_xy[[1]][283])),ttick,'y')
legend("topright","(x,y)",
	pch=c(-1,21,23,25),
	lwd=c(1,1,1,1),
	legend=c("RMSE","50%","75%","90%"),
	col=rep('black',4),
	pt.bg=rep('gray50',4),
	lty=c(1,1,0,0))
add_legend(things_to_error$display_name,things_to_error$colors,things_to_error$linetypes,1,'topleft')
dev.off()

svg(filename='Plots/westimates.svg',width=6,height=10,pointsize=7)
par(mar=c(4.5,4.5,.3,.3),family='M+ 2c regular')
this_layout = matrix(c(1,2,3,4,5),5,1,TRUE)
layout(this_layout)
mvals = c(1,0.01,0.3,0.3,0.01)
for(ind in 1:5){
plot(c(),c(),
	xlab='Index',ylab=sprintf('w_%d value',ind),
	xaxt='n',yaxt='n',
	xlim=c(1,282),ylim=c(-mvals[ind],mvals[ind]))
abline(v=c(1,282),h=c(-mvals[ind],0,mvals[ind]),lty=1,lwd=0.5,col='lightgray')
axis(side=1, at = c(1,282))
axis(side=2, at = c(-mvals[ind],0,mvals[ind]))
lines(run1$dataset[[num]]$truth_ws[ind,],type='p',col='black')
lines(run1$dataset[[num]]$filter00_wval_1[ind,],type='p',col=clist$crimson)
}
par(mfg=c(1,1))
legend('topright','(x,y)',
	pch=c(1,1),
	lwd=c(2,2),
	legend=c('Truth','Estimate'),
	col=c('black',clist$crimson),
	lty=c(-1,-1))
dev.off()

svg(filename='Plots/vestimates.svg',width=6,height=4,pointsize=7)
par(mar=c(4.5,4.5,.3,.3),family='M+ 2c regular')
this_layout = matrix(c(1,2),2,1,TRUE)
layout(this_layout)
mvals = c(.1,.1)
plot(c(),c(),
	xlab='Index',ylab=sprintf('n_%d value',1),
	xaxt='n',yaxt='n',
	xlim=ttick[c(1,length(ttick))],ylim=c(-mvals[1],mvals[1]))
abline(v=ttick,h=c(-mvals[1],0,mvals[1]),lty=1,lwd=0.5,col='lightgray')
axis(side=1, at = c(1,282))
axis(side=2, at = c(-mvals[1],0,mvals[1]))
useval = rep(c(FALSE,TRUE,FALSE,FALSE,FALSE,FALSE),47)
useval = useval[1:282]
lines((1:282)[useval],run1$dataset[[num]]$truth_ns[1,useval],type='p',col='black')
lines((1:282)[useval],run1$dataset[[num]]$filter00_nval_1[1,useval],type='p',col=clist$crimson)
plot(c(),c(),
	xlab='Index',ylab=sprintf('n_%d value',2),
	xaxt='n',yaxt='n',
	xlim=ttick[c(1,length(ttick))],ylim=c(-mvals[2],mvals[2]))
abline(v=ttick,h=c(-mvals[2],0,mvals[2]),lty=1,lwd=0.5,col='lightgray')
axis(side=1, at = ttick)
axis(side=2, at = c(-mvals[2],0,mvals[2]))
useval = rep(c(FALSE,FALSE,FALSE,FALSE,TRUE,FALSE),47)
useval = useval[1:282]
lines((1:282)[useval],run1$dataset[[num]]$truth_ns[2,useval],type='p',col='black')
lines((1:282)[useval],run1$dataset[[num]]$filter00_nval_1[2,useval],type='p',col=clist$crimson)
par(mfg=c(1,1))
legend('topright','(x,y)',
	pch=c(1,1),
	lwd=c(2,2),
	legend=c('Truth','Estimate'),
	col=c('black',clist$crimson),
	lty=c(-1,-1))
dev.off()

##UKF plot 1

things_to_plot = add_to_things_to_plot(run5$dataset[[num]],'truth_state','Truth','black',1)
things_to_plot = add_to_things_to_plot(run5$dataset[[num]],'filter00_forward_1','UKF (O5)',clist$dgreen,1,things_to_plot)
things_to_plot = add_to_things_to_plot(run5$dataset[[num]],'filter00_back_1','UKF (O5 Smoothed)',clist$lgreen,2,things_to_plot)

# XY
generate_xy(things_to_plot,'UKF1',xtick,ytick,ttick)
add_legend(things_to_plot$display_name,things_to_plot$colors,things_to_plot$linetypes)
dev.off()

# XY small mult
xy_small_mult(run5$dataset,'UKF1',things_to_plot,xtick,ytick)
dev.off()

things_to_error = add_to_things_to_error(run1$dataset,'filter00_forward_1','Perfect KF',clist$crimson,1)
things_to_error = add_to_things_to_error(run4$dataset,'filter00_forward_1','EKF',clist$curry,1,things_to_error)
things_to_error = add_to_things_to_error(run5$dataset,'filter00_forward_1','UKF (O5)',clist$dgreen,1,things_to_error)
# Error plot
plot_errors(things_to_error,'UKF1_Smoothed',c(0.1,1000),sort(c(1,10,100,things_to_error$q50_xy[[1]][283],things_to_error$q50_xy[[2]][283],things_to_error$q50_xy[[3]][283])),ttick,'y')
legend('topleft',"(x,y)",
	pch=c(-1,21,23,25),
	lwd=c(1,1,1,1),
	legend=c("RMSE","50%","75%","90%"),
	col=rep('black',4),
	pt.bg=rep('gray50',4),
	lty=c(1,1,0,0))
add_legend(things_to_error$display_name,things_to_error$colors,things_to_error$linetypes,1,'topright')
dev.off()

##UKF plot 2
things_to_plot = add_to_things_to_plot(run1$dataset[[num]],'truth_state','Truth','black',1)
things_to_plot = add_to_things_to_plot(run5$dataset[[num]],'filter01_forward_1','UKF (O7 0.4)',clist$dgreen,1,things_to_plot)
things_to_plot = add_to_things_to_plot(run5$dataset[[num]],'filter01_back_1','UKF (O7 0.4 Smoothed)',clist$lgreen,2,things_to_plot)

# XY
generate_xy(things_to_plot,'UKF2',xtick,ytick,ttick)
add_legend(things_to_plot$display_name,things_to_plot$colors,things_to_plot$linetypes)
dev.off()

# XY small mult
xy_small_mult(run5$dataset,'UKF2',things_to_plot,xtick,ytick)
dev.off()

things_to_error = add_to_things_to_error(run1$dataset,'filter00_forward_1','Perfect KF',clist$crimson,1)
things_to_error = add_to_things_to_error(run4$dataset,'filter00_forward_1','EKF',clist$curry,1,things_to_error)
things_to_error = add_to_things_to_error(run5$dataset,'filter01_forward_1','UKF (O7 0.4)',clist$dgreen,1,things_to_error)
# Error plot
plot_errors(things_to_error,'UKF2_Smoothed',c(0.1,1000),sort(c(1,10,100,things_to_error$q50_xy[[1]][283],things_to_error$q50_xy[[2]][283],things_to_error$q50_xy[[3]][283])),ttick,'y')
legend('topleft',"(x,y)",
	pch=c(-1,21,23,25),
	lwd=c(1,1,1,1),
	legend=c("RMSE","50%","75%","90%"),
	col=rep('black',4),
	pt.bg=rep('gray50',4),
	lty=c(1,1,0,0))
add_legend(things_to_error$display_name,things_to_error$colors,things_to_error$linetypes,1,'topright')
dev.off()

things_to_error = add_to_things_to_error(run1$dataset,'filter00_back_1','Perfect KF (Smoothed)',clist$purple,1)
things_to_error = add_to_things_to_error(run4$dataset,'filter00_back_19','IS (Smoothed 19)',clist$curry,1,things_to_error)
things_to_error = add_to_things_to_error(run5$dataset,'filter01_back_19','UKF (O7 0.4 Smoothed, Pass 19)',clist$lgreen,1,things_to_error)
# Error plot
plot_errors(things_to_error,'UKF2_Smoothed20',c(0.1,1000),sort(c(1,10,100,things_to_error$q50_xy[[2]][283],things_to_error$q50_xy[[3]][283])),ttick,'y')
legend('topleft',"(x,y)",
	pch=c(-1,21,23,25),
	lwd=c(1,1,1,1),
	legend=c("RMSE","50%","75%","90%"),
	col=rep('black',4),
	pt.bg=rep('gray50',4),
	lty=c(1,1,0,0))
add_legend(things_to_error$display_name,things_to_error$colors,things_to_error$linetypes,1,'topright')
dev.off()

##UKF 3 plot
things_to_error = add_to_things_to_error(run1$dataset,'filter00_back_1','Perfect KF (Smoothed)',clist$purple,1)
things_to_error = add_to_things_to_error(run5$dataset,'filter02_back_19','UKF (O7 0.65 Smoothed, Pass 19)',clist$lgreen,1,things_to_error)
# Error plot
plot_errors(things_to_error,'UKF3_Smoothed20',c(0.1,1000),sort(c(1,10,100,things_to_error$q50_xy[[1]][283],things_to_error$q50_xy[[2]][283])),ttick,'y')
legend('topleft',"(x,y)",
	pch=c(-1,21,23,25),
	lwd=c(1,1,1,1),
	legend=c("RMSE","50%","75%","90%"),
	col=rep('black',4),
	pt.bg=rep('gray50',4),
	lty=c(1,1,0,0))
add_legend(things_to_error$display_name,things_to_error$colors,things_to_error$linetypes,1,'topright')
dev.off()
