source('./blindtricycle_functions.R')

num_runs = 100

if(!exists('gotdata') || !gotdata) {
	run1 = list()
	run1$name = 'Perfects'
	run1$filter_names = c(
		'KF (S,W)',
		'KF (S)',
		'KF (W)' )
	run1$dataset = pull_in_datasets('AltRuns/RunRun',run1$name,1:num_runs)

	run4 = list()
	run4$name = 'EKF'
	run4$dataset = pull_in_datasets('AltRuns/RunRun',run4$name,1:num_runs)

	run5 = list()
	run5$name = 'Sigma'
	run5$filter_names = c(
		'UKF (O5)',
		'UKF (O7 0.4)',
		'FP UKF (O7 0.4)')
	run5$dataset = pull_in_datasets('AltRuns/RunRun',run5$name,1:num_runs)

	gotdata = TRUE
}

### Going to plot just run 4 as a demo
num = 4

ttick = c(0,60,90,120,150,180,206,256)/2
xtick = c(-20,0,40,80)
ytick = c(-40,0,40,60)


## Perfect Plots
things_to_plot = add_to_things_to_plot(run1$dataset[[num]],'truth_state','Truth','black',1)
things_to_plot = add_to_things_to_plot(run1$dataset[[num]],'filter00_forward_1','Perfect KF',clist$crimson,1,things_to_plot)
things_to_plot = add_to_things_to_plot(run1$dataset[[num]],'filter00_back_1','Perfect KF (Smoothed)',clist$purple,2,things_to_plot)

generate_xy(things_to_plot,'alt_PEKF',xtick,ytick,ttick)
add_legend(things_to_plot$display_name,things_to_plot$colors,things_to_plot$linetypes)
dev.off()

xy_small_mult(run1$dataset,'alt_PEKF',things_to_plot,xtick,ytick)
dev.off()

sigmas = sqrt(run1$dataset[[1]]$filter00_pval[1,]+run1$dataset[[1]]$filter00_pval[2,])
things_to_error = add_to_things_to_error(run1$dataset,'filter00_forward_1','Perfect KF',clist$crimson,1)
plot_errors(things_to_error,'alt_PEKF',c(.1,1000),sort(c(1,10,100,things_to_error$q50_xy[[1]][255])),ttick,'y')
lines(run1$dataset[[1]]$time,sigmas,type='l',col='black')
legend("bottomleft","(x,y)",
	pch=c(-1,-1,21,23,25),
	lwd=c(1,1,1,1,1),
	legend=c("RMSE bound","RMSE","50%","75%","90%"),
	col=c('black',clist$crimson,makeTransparent(clist$crimson,50),clist$crimson,clist$crimson),
	pt.bg=rep(clist$crimson,5),
	lty=c(1,1,1,0,0))
dev.off()
things_to_error$things=0
plot_errors(things_to_error,'alt_PEKF_justsig',c(.1,1000),sort(c(1,sigmas[255],10,100)),ttick,'y')
lines(run1$dataset[[1]]$time,sigmas,type='l',col='black')
dev.off()

things_to_error = add_to_things_to_error(run1$dataset,'filter00_forward_1','Perfect KF',clist$crimson,1)
things_to_error = add_to_things_to_error(run1$dataset,'filter00_back_1','Perfect KF (Smoothed)',clist$purple,1,things_to_error)
plot_errors(things_to_error,'alt_PEKF_Smooth',c(.1,1000),sort(c(1,10,100,things_to_error$q50_xy[[1]][255])),ttick,'y')
legend("topleft","(x,y)",
	pch=c(-1,21,23,25),
	lwd=c(1,1,1,1),
	legend=c("RMSE","50%","75%","90%"),
	col=rep('grey50',4),
	pt.bg=rep('black',4),
	lty=c(1,1,0,0))
add_legend(things_to_error$display_name,things_to_error$colors,things_to_error$linetypes,1,'topright')
dev.off()

##EKF plot 1
things_to_plot = add_to_things_to_plot(run4$dataset[[num]],'truth_state','Truth','black',1)
things_to_plot = add_to_things_to_plot(run4$dataset[[num]],'filter00_forward_1','EKF',clist$curry,1,things_to_plot)
things_to_plot = add_to_things_to_plot(run4$dataset[[num]],'filter00_back_1','EKF (Smoothed)',clist$khaki,2,things_to_plot)

generate_xy(things_to_plot,'alt_EKF',xtick,ytick,ttick)
add_legend(things_to_plot$display_name,things_to_plot$colors,things_to_plot$linetypes)
dev.off()

xy_small_mult(run4$dataset,'alt_EKF',things_to_plot,xtick,ytick)
dev.off()

things_to_error = add_to_things_to_error(run4$dataset,'filter00_forward_1','EKF',clist$curry,1)
plot_errors(things_to_error,'alt_EKF',c(.1,1000),sort(c(.1,100,things_to_error$q50_xy[[1]][255])),ttick,'y')
legend("bottomleft","(x,y)",
	pch=c(-1,21,23,25),
	lwd=c(1,1,1,1),
	legend=c("RMSE","50%","75%","90%"),
	col=c(clist$curry,makeTransparent(clist$curry,50),clist$curry,clist$curry),
	pt.bg=rep(clist$curry,4),
	lty=c(1,1,0,0))
dev.off()

things_to_error = add_to_things_to_error(run4$dataset,'filter00_back_1','EKF (Smoothed)',clist$khaki,1)
plot_errors(things_to_error,'alt_EKF_Smooth',c(0.1,1000),sort(c(.1,100,things_to_error$q50_xy[[1]][255])),ttick,'y')
dev.off()

things_to_error = add_to_things_to_error(run1$dataset,'filter00_forward_1','Perfect KF',clist$crimson,1)
things_to_error = add_to_things_to_error(run4$dataset,'filter00_forward_1','EKF',clist$curry,1,things_to_error)
plot_errors(things_to_error,'alt_EKF_Compare',c(0.1,1000),sort(c(1,100,things_to_error$q50_xy[[1]][255],things_to_error$q50_xy[[2]][255])),ttick,'y')
add_legend(things_to_error$display_name,things_to_error$colors,things_to_error$linetypes,1,'bottomleft')
dev.off()

things_to_error = add_to_things_to_error(run1$dataset,'filter00_forward_1','Perfect KF',clist$crimson,1)
things_to_error = add_to_things_to_error(run1$dataset,'filter00_back_1','Perfect KF (Smoothed)',clist$purple,1,things_to_error)
things_to_error = add_to_things_to_error(run4$dataset,'filter00_forward_1','EKF',clist$curry,1,things_to_error)
things_to_error = add_to_things_to_error(run4$dataset,'filter00_back_1','EKF (Smoothed)',clist$khaki,1,things_to_error)
plot_errors(things_to_error,'alt_EKF_Compare_Smoothed',c(0.1,1000),sort(c(1,100,things_to_error$q50_xy[[1]][255],things_to_error$q50_xy[[3]][255])),ttick,'y')
legend('topleft',"(x,y)",
	pch=c(-1,21,23,25),
	lwd=c(1,1,1,1),
	legend=c("RMSE","50%","75%","90%"),
	col=rep('black',4),
#	col=c(clist$khaki,makeTransparent(clist$khaki,50),clist$khaki,clist$khaki),
	pt.bg=rep('gray50',4),
	lty=c(1,1,0,0))
add_legend(things_to_error$display_name,things_to_error$colors,things_to_error$linetypes,1,'topright')
dev.off()

## Iterative Smoother
things_to_plot = add_to_things_to_plot(run4$dataset[[num]],'truth_state','Truth','black',1)
things_to_plot = add_to_things_to_plot(run4$dataset[[num]],'filter00_forward_1','EKF',clist$curry,1,things_to_plot)
things_to_plot = add_to_things_to_plot(run4$dataset[[num]],'filter00_back_1','EKF (Smoothed)',clist$curry,2,things_to_plot)
things_to_plot = add_to_things_to_plot(run4$dataset[[num]],'filter00_forward_2','IS (Iter 1)',clist$khaki,1,things_to_plot)
things_to_plot = add_to_things_to_plot(run4$dataset[[num]],'filter00_back_2','IS (Smoothed 1)',clist$crimson,2,things_to_plot)

generate_xy(things_to_plot,'alt_IS_2',xtick,ytick,ttick)
add_legend(things_to_plot$display_name,things_to_plot$colors,things_to_plot$linetypes)
dev.off()

xy_small_mult(run4$dataset,'alt_IS_2',things_to_plot,xtick,ytick)
dev.off()

things_to_error = add_to_things_to_error(run4$dataset,'filter00_back_1','EKF (Smoothed)',clist$curry,1)
things_to_error = add_to_things_to_error(run4$dataset,'filter00_back_2','IS (Smoothed 1)',clist$khaki,1,things_to_error)
plot_errors(things_to_error,'alt_IS_2_Smooth',c(0.1,1000),sort(c(.1,1,100,things_to_error$q50_xy[[2]][255])),ttick,'y')
legend("bottomright","(x,y)",
	pch=c(-1,21,23,25),
	lwd=c(1,1,1,1),
	legend=c("RMSE","50%","75%","90%"),
	col=rep('black',4),
	pt.bg=rep('gray50',4),
	lty=c(1,1,0,0))
add_legend(things_to_error$display_name,things_to_error$colors,things_to_error$linetypes,1,'bottomleft')
dev.off()

things_to_error = add_to_things_to_error(run1$dataset,'filter00_back_1','Perfect KF',clist$purple,1)
things_to_error = add_to_things_to_error(run1$dataset,'filter00_back_20','IS (Smoothed 19, Perfect Init)',clist$lgreen,2,things_to_error)
plot_errors(things_to_error,'alt_PIS_20_Smooth',c(0.1,1000),sort(c(1,100,things_to_error$q50_xy[[1]][255],things_to_error$q50_xy[[2]][255])),ttick,'y')
legend("topright","(x,y)",
	pch=c(-1,21,23,25),
	lwd=c(1,1,1,1),
	legend=c("RMSE","50%","75%","90%"),
	col=rep('black',4),
	pt.bg=rep('gray50',4),
	lty=c(1,1,0,0))
add_legend(things_to_error$display_name,things_to_error$colors,things_to_error$linetypes,1,'topleft')
dev.off()

things_to_plot = add_to_things_to_plot(run4$dataset[[num]],'truth_state','Truth','black',1)
things_to_plot = add_to_things_to_plot(run4$dataset[[num]],'filter00_back_19','IS (Smoothed 18)',clist$lblue,1,things_to_plot)
things_to_plot = add_to_things_to_plot(run4$dataset[[num]],'filter00_back_20','IS (Smoothed 19)',clist$lgreen,2,things_to_plot)

generate_xy(things_to_plot,'alt_IS_20',xtick,ytick,ttick)
add_legend(things_to_plot$display_name,things_to_plot$colors,things_to_plot$linetypes)
dev.off()

xy_small_mult(run4$dataset,'alt_IS_20',things_to_plot,xtick,ytick)
dev.off()

things_to_error = add_to_things_to_error(run4$dataset,'filter00_back_1','EKF (Smoothed)',clist$curry,1)
things_to_error = add_to_things_to_error(run4$dataset,'filter00_back_20','IS (Smoothed 19)',clist$lgreen,1,things_to_error)
things_to_error = add_to_things_to_error(run1$dataset,'filter00_back_1','Perfect KF (Smoothed)',clist$purple,1,things_to_error)
plot_errors(things_to_error,'alt_IS_20_Smooth',c(0.1,1000),sort(c(100,1,things_to_error$q50_xy[[2]][255],things_to_error$q50_xy[[3]][255])),ttick,'y')
legend("topright","(x,y)",
	pch=c(-1,21,23,25),
	lwd=c(1,1,1,1),
	legend=c("RMSE","50%","75%","90%"),
	col=rep('black',4),
	pt.bg=rep('gray50',4),
	lty=c(1,1,0,0))
add_legend(things_to_error$display_name,things_to_error$colors,things_to_error$linetypes,1,'topleft')
dev.off()

# BSEKF

things_to_error = add_to_things_to_error(run4$dataset,'filter00_back_20','IS (Smoothed 19)',clist$lgreen,1)
things_to_error = add_to_things_to_error(run4$dataset,'filter01_back_20','BSEKF (Smoothed 19)',clist$dblue,2,things_to_error)
plot_errors(things_to_error,'alt_BSEKF_20_Smooth',c(0.1,1000),sort(c(100,1,things_to_error$q50_xy[[1]][255])),ttick,'y')
legend("topright","(x,y)",
	pch=c(-1,21,23,25),
	lwd=c(1,1,1,1),
	legend=c("RMSE","50%","75%","90%"),
	col=rep('black',4),
	pt.bg=rep('gray50',4),
	lty=c(1,1,0,0))
add_legend(things_to_error$display_name,things_to_error$colors,things_to_error$linetypes,1,'topleft')
dev.off()

things_to_error = add_to_things_to_error(run1$dataset,'filter00_back_1','Perfect KF (Smoothed)',clist$purple,1)
things_to_error = add_to_things_to_error(run1$dataset,'filter01_back_1','Just X PKF (Smoothed)',clist$dgreen,2,things_to_error)
plot_errors(things_to_error,'alt_Perfect_noW_20_Smooth',c(0.1,1000),sort(c(10,100,1,things_to_error$q50_xy[[1]][255])),ttick,'y')
legend("topright","(x,y)",
	pch=c(-1,21,23,25),
	lwd=c(1,1,1,1),
	legend=c("RMSE","50%","75%","90%"),
	col=rep('black',4),
	pt.bg=rep('gray50',4),
	lty=c(1,1,0,0))
add_legend(things_to_error$display_name,things_to_error$colors,things_to_error$linetypes,1,'topleft')
dev.off()


##UKF plot 1

things_to_plot = add_to_things_to_plot(run5$dataset[[num]],'truth_state','Truth','black',1)
things_to_plot = add_to_things_to_plot(run5$dataset[[num]],'filter00_forward_1','UKF (O5)',clist$dgreen,1,things_to_plot)
things_to_plot = add_to_things_to_plot(run5$dataset[[num]],'filter00_back_1','UKF (O5 Smoothed)',clist$lgreen,2,things_to_plot)

# XY
generate_xy(things_to_plot,'alt_UKF1',xtick,ytick,ttick)
add_legend(things_to_plot$display_name,things_to_plot$colors,things_to_plot$linetypes)
dev.off()

# XY small mult
xy_small_mult(run5$dataset,'alt_UKF1',things_to_plot,xtick,ytick)
dev.off()

things_to_error = add_to_things_to_error(run1$dataset,'filter00_forward_1','Perfect KF',clist$crimson,1)
things_to_error = add_to_things_to_error(run1$dataset,'filter00_back_1','Perfect KF (Smoothed)',clist$purple,1,things_to_error)
things_to_error = add_to_things_to_error(run5$dataset,'filter00_forward_1','UKF (O5)',clist$dgreen,1,things_to_error)
things_to_error = add_to_things_to_error(run5$dataset,'filter00_back_1','UKF (O5 Smoothed)',clist$lgreen,1,things_to_error)
# Error plot
plot_errors(things_to_error,'alt_UKF1_Smoothed',c(0.1,1000),sort(c(1,100,things_to_error$q50_xy[[1]][255],things_to_error$q50_xy[[3]][255])),ttick,'y')
legend('topleft',"(x,y)",
	pch=c(-1,21,23,25),
	lwd=c(1,1,1,1),
	legend=c("RMSE","50%","75%","90%"),
	col=rep('black',4),
	pt.bg=rep('gray50',4),
	lty=c(1,1,0,0))
add_legend(things_to_error$display_name,things_to_error$colors,things_to_error$linetypes,1,'topright')
dev.off()

##UKF plot 2
things_to_plot = add_to_things_to_plot(run1$dataset[[num]],'truth_state','Truth','black',1)
things_to_plot = add_to_things_to_plot(run5$dataset[[num]],'filter01_forward_1','UKF (O7 0.4)',clist$dgreen,1,things_to_plot)
things_to_plot = add_to_things_to_plot(run5$dataset[[num]],'filter01_back_1','UKF (O7 0.4 Smoothed)',clist$lgreen,2,things_to_plot)

# XY
generate_xy(things_to_plot,'alt_UKF2',xtick,ytick,ttick)
add_legend(things_to_plot$display_name,things_to_plot$colors,things_to_plot$linetypes)
dev.off()

# XY small mult
xy_small_mult(run5$dataset,'alt_UKF2',things_to_plot,xtick,ytick)
dev.off()

things_to_error = add_to_things_to_error(run1$dataset,'filter00_forward_1','Perfect KF',clist$crimson,1)
things_to_error = add_to_things_to_error(run1$dataset,'filter00_back_1','Perfect KF (Smoothed)',clist$purple,1,things_to_error)
things_to_error = add_to_things_to_error(run5$dataset,'filter01_forward_1','UKF (O7 0.4)',clist$dgreen,1,things_to_error)
things_to_error = add_to_things_to_error(run5$dataset,'filter01_back_1','UKF (O7 0.4 Smoothed)',clist$lgreen,1,things_to_error)
# Error plot
plot_errors(things_to_error,'alt_UKF2_Smoothed',c(0.1,1000),sort(c(100,things_to_error$q50_xy[[1]][255],things_to_error$q50_xy[[3]][255])),ttick,'y')
legend('topleft',"(x,y)",
	pch=c(-1,21,23,25),
	lwd=c(1,1,1,1),
	legend=c("RMSE","50%","75%","90%"),
	col=rep('black',4),
	pt.bg=rep('gray50',4),
	lty=c(1,1,0,0))
add_legend(things_to_error$display_name,things_to_error$colors,things_to_error$linetypes,1,'topright')
dev.off()

things_to_error = add_to_things_to_error(run1$dataset,'filter00_back_1','Perfect KF (Smoothed)',clist$purple,1)
things_to_error = add_to_things_to_error(run4$dataset,'filter00_back_19','IS (Smoothed 19)',clist$curry,1,things_to_error)
things_to_error = add_to_things_to_error(run5$dataset,'filter01_back_19','UKF (O7 0.4 Smoothed, Pass 19)',clist$lgreen,1,things_to_error)
# Error plot
plot_errors(things_to_error,'alt_UKF2_Smoothed20',c(0.1,1000),sort(c(1,10,100,things_to_error$q50_xy[[2]][255],things_to_error$q50_xy[[3]][255])),ttick,'y')
legend('topleft',"(x,y)",
	pch=c(-1,21,23,25),
	lwd=c(1,1,1,1),
	legend=c("RMSE","50%","75%","90%"),
	col=rep('black',4),
	pt.bg=rep('gray50',4),
	lty=c(1,1,0,0))
add_legend(things_to_error$display_name,things_to_error$colors,things_to_error$linetypes,1,'topright')
dev.off()

##UKF 3 plot
things_to_error = add_to_things_to_error(run1$dataset,'filter00_back_1','Perfect KF (Smoothed)',clist$purple,1)
things_to_error = add_to_things_to_error(run5$dataset,'filter02_back_19','UKF (O7 0.65 Smoothed, Pass 19)',clist$lgreen,1,things_to_error)
# Error plot
plot_errors(things_to_error,'alt_UKF3_Smoothed20',c(0.1,1000),sort(c(100,things_to_error$q50_xy[[1]][255],things_to_error$q50_xy[[2]][255])),ttick,'y')
legend('topleft',"(x,y)",
	pch=c(-1,21,23,25),
	lwd=c(1,1,1,1),
	legend=c("RMSE","50%","75%","90%"),
	col=rep('black',4),
	pt.bg=rep('gray50',4),
	lty=c(1,1,0,0))
add_legend(things_to_error$display_name,things_to_error$colors,things_to_error$linetypes,1,'topright')
dev.off()
