#ifndef EKF_H_
#define EKF_H_

#include "LinearFilters.h"


template <unsigned short n, unsigned short p, typename U>
ADVANCEMENT<n,p> ekfAdvance(ADVPROTO<n,p,U> &linp) {
	ADVANCEMENT<n,p> rval;
	rval.havenonlin = false;

	rval.x = linp.fun(&rval.F,&rval.L,linp.state.mean,linp.noise.mean,linp.forcing);
	rval.x = rval.x - rval.F*linp.state.mean - rval.L*linp.noise.mean;

	return rval;
};

template <unsigned short n, unsigned short p, unsigned short t, typename U>
MEASUREMENT<n,p,t> ekfMeasurement(MEASPROTO<n,p,t,U> &linp) {
	MEASUREMENT<n,p,t> rval;
  rval.havenonlin = false;

	rval.y = linp.fun(&rval.H,&rval.V,linp.state.mean,linp.noise.mean,linp.forcing);
	rval.y = rval.y - rval.H*linp.state.mean - rval.V*linp.noise.mean;

	return rval;
};


#endif /* EKF_H_ */
